in vec4 vVertexAlbedo;

uniform int uViewportWidth;
uniform int uViewportHeight;
uniform mat4 uMatA;
uniform mat4 uMatAInv;
uniform float uT;

void main()
{
   // Get some normalised coords
   vec2 viewport = vec2(uViewportWidth, uViewportHeight);
   vec2 normalisedCoords = gl_FragCoord.xy / viewport;
   mat4 matB;
   mat4 matC = mat4(1.0);
   // Do a load of iteration that do some math, but always result in identity, so we can render the results to the screen
   for(int i = 0; i < 2; ++i)
   {
      matB = uMatA * uMatAInv;
      // matB should always be identity (plus some error), but there should be no way the optimiser can know this...
      matC = matC * matB;
      vec4 sC0 = sin(matC[0]);
      vec4 cC0 = cos(matC[0]);
      mat4 sMC = mat4(sC0, sC0, sC0, sC0);
      mat4 cMC = mat4(cC0, cC0, cC0, cC0);
      // With this identity, z is a matrix of ones];
      mat4 z = matrixCompMult(sMC, sMC) + matrixCompMult(cMC, cMC);
      // matC should still be identity
      matC = matrixCompMult(matC, z);
   }
   // Pointless operation...
   float x = (normalisedCoords.x + uT) * 2.0 * 3.141;
   float y = (normalisedCoords.y + uT) * 2.0 * 3.141;
   vec4 boop = vec4((sin(x) + 1.0) * 0.5, (cos(y) + 1.0) * 0.5, 0.0, 1.0) * matC;
   vec4 finalColour = boop;
   gl_FragColor = finalColour;
}
