attribute vec3 aPos;
attribute vec4 aColour;

uniform mat4 uWorldMat;
uniform mat4 uViewProjMat;

out vec4 vVertexAlbedo;

void main()
{
   vec4 worldPos = uWorldMat * vec4(aPos.x, aPos.y, aPos.z, 1.0);
   vec4 clipPos = uViewProjMat * worldPos;

   vVertexAlbedo = aColour;

   gl_Position = clipPos;
}
