uniform vec3 uSamplePixelSizeAndIteration;

in vec2 vTexCoord;

uniform sampler2D sSourceTex;

#include "DepthOfFieldShared.inc"

void main()
{
    vec2 samplePixelSize = uSamplePixelSizeAndIteration.xy;
    float iteration = uSamplePixelSizeAndIteration.z;

    vec4 currentTexel = texture2DLodCompat(sSourceTex, vTexCoord, 0.0);

    vec4 filter12 = vec4(0.0), filter34 = vec4(0.0);
    float slice = 0.0;
    KawaseFilter2(sSourceTex, vTexCoord, samplePixelSize, iteration, filter12, filter34, slice);

    vec2 filterSum = filter12.xy + filter12.zw + filter34.xy + filter34.zw;
    // Blur and dilate near and far focus values
    // For near, this produces nicer soft edges in the final image
    // For far, this reduces artifacts incurred from scene blur early-out optimisation
    vec2 filterBlurDilate = filterSum * 0.4;

    // Dilated near, dilated far
    gl_FragColor.rg = filterBlurDilate;
}
