
#include "Shared/DepthUtils.inc"
#include "KawaseFilter.inc"

uniform highp float uDofFocalPoint;
uniform highp vec4 uDofParams; //near, near distance, far, far distance
uniform highp vec4 uZBufferParams; //x = near * far, y = near - far, z = far, w = 1 / far

vec2 GetFocus(highp float depth)
{
    highp float focalPlane = GetViewSpaceDepth(depth, uZBufferParams.xyz) - uDofFocalPoint;
    float near = step(0.0, uDofParams.y) * smoothstep(uDofParams.x, uDofParams.x + uDofParams.y, -focalPlane);
    float far = step(0.0, uDofParams.w) * smoothstep(uDofParams.z, uDofParams.z + uDofParams.w, focalPlane);
    return vec2(near, far);
}
