uniform samplerCube sCubeMap;

in vec2 vTexCoord;

// Converts the input coordinate to a polar coordinate to sample from the cubemap
vec3 CubeToLatLon(vec2 inUV)
{
    const float PI = 3.14158265359;
    vec3 cubemapTexCoords;
    float sinYPi = sin(inUV.y * PI);
    cubemapTexCoords.x = sin(inUV.x * PI * 2.0) * sinYPi;
    cubemapTexCoords.y = -cos(inUV.y * PI);
    cubemapTexCoords.z = -cos(inUV.x * PI * 2.0) * sinYPi;
    return cubemapTexCoords;
}

void main()
{
    vec3 polarCoords = CubeToLatLon(vTexCoord);
    vec4 colour = textureCube(sCubeMap, polarCoords);
    colour.a = 1.0;
    gl_FragColor = colour;
}
