uniform vec4 uSampleOffsetsWeights[13];

#if defined(USE_TEXTURE_ARRAY)
    uniform sampler2DArray sSourceTex;
    uniform float uSourceTexSlice;
#else
    uniform sampler2D sSourceTex;
#endif

in vec2 vTexCoord;

void main()
{
    //[
#if defined(USE_TEXTURE_ARRAY)
    vec3 texCoord = vec3(vTexCoord.xy + uSampleOffsetsWeights[0].xy, uSourceTexSlice);
#else
    vec2 texCoord = vec2(vTexCoord.xy + uSampleOffsetsWeights[0].xy);
#endif
    //]
    vec3 rgb = texture2DLodCompat(sSourceTex, texCoord, 0.0).rgb * uSampleOffsetsWeights[0].z;
    texCoord.xy = vTexCoord.xy + uSampleOffsetsWeights[1].xy;
    rgb += texture2DLodCompat(sSourceTex, texCoord, 0.0).rgb * uSampleOffsetsWeights[1].z;
    texCoord.xy = vTexCoord.xy + uSampleOffsetsWeights[2].xy;
    rgb += texture2DLodCompat(sSourceTex, texCoord, 0.0).rgb * uSampleOffsetsWeights[2].z;
    texCoord.xy = vTexCoord.xy + uSampleOffsetsWeights[3].xy;
    rgb += texture2DLodCompat(sSourceTex, texCoord, 0.0).rgb * uSampleOffsetsWeights[3].z;
    texCoord.xy = vTexCoord.xy + uSampleOffsetsWeights[4].xy;
    rgb += texture2DLodCompat(sSourceTex, texCoord, 0.0).rgb * uSampleOffsetsWeights[4].z;
    texCoord.xy = vTexCoord.xy + uSampleOffsetsWeights[5].xy;
    rgb += texture2DLodCompat(sSourceTex, texCoord, 0.0).rgb * uSampleOffsetsWeights[5].z;
    texCoord.xy = vTexCoord.xy + uSampleOffsetsWeights[6].xy;
    rgb += texture2DLodCompat(sSourceTex, texCoord, 0.0).rgb * uSampleOffsetsWeights[6].z;
    texCoord.xy = vTexCoord.xy + uSampleOffsetsWeights[7].xy;
    rgb += texture2DLodCompat(sSourceTex, texCoord, 0.0).rgb * uSampleOffsetsWeights[7].z;
    texCoord.xy = vTexCoord.xy + uSampleOffsetsWeights[8].xy;
    rgb += texture2DLodCompat(sSourceTex, texCoord, 0.0).rgb * uSampleOffsetsWeights[8].z;
    texCoord.xy = vTexCoord.xy + uSampleOffsetsWeights[9].xy;
    rgb += texture2DLodCompat(sSourceTex, texCoord, 0.0).rgb * uSampleOffsetsWeights[9].z;
    texCoord.xy = vTexCoord.xy + uSampleOffsetsWeights[10].xy;
    rgb += texture2DLodCompat(sSourceTex, texCoord, 0.0).rgb * uSampleOffsetsWeights[10].z;
    texCoord.xy = vTexCoord.xy + uSampleOffsetsWeights[11].xy;
    rgb += texture2DLodCompat(sSourceTex, texCoord, 0.0).rgb * uSampleOffsetsWeights[11].z;
    texCoord.xy = vTexCoord.xy + uSampleOffsetsWeights[12].xy;
    rgb += texture2DLodCompat(sSourceTex, texCoord, 0.0).rgb * uSampleOffsetsWeights[12].z;

    // Write output to r channel
    gl_FragColor = vec4(rgb, 1.0);
}
