#include "KawaseFilter.inc"

uniform float uSourceTexSlice;
uniform KAWASE_SAMPLER_TYPE sSourceTex;
uniform vec3 uSamplePixelSizeAndIteration;

in vec2 vTexCoord;

vec3 KawaseBlurFilter(KAWASE_SAMPLER_TYPE tex, vec2 uv, vec2 pixelSize, float iteration)
{
    vec3 result1, result2, result3, result4;
    KawaseFilter3(tex, uv, pixelSize, iteration, result1, result2, result3, result4, uSourceTexSlice);
    return (result1 + result2 + result3 + result4) * 0.25;
}

void main()
{
    vec3 rgb = KawaseBlurFilter(sSourceTex, vTexCoord, uSamplePixelSizeAndIteration.xy, uSamplePixelSizeAndIteration.z);
    gl_FragColor = vec4(rgb, 1.0);
}
