//Main function
void main()
{
    vec4 fragColour;

    TextureSettings textureSettings;
    getTextureSettings(vMaterialSettingsSlotXY, textureSettings);

    vec4 texelAlbedo = vec4(1.0);
    //HDR scaling
    #if defined(HDR_SCALE)
        vec4 texelHDRNormal = vec4(0.0);
        getTexel(vTextureUV, textureSettings.textureMeta1, textureSettings.textureMeta2, uAtlasMeta, textureSettings.wrapping, uTextureAtlas, texelAlbedo, texelHDRNormal);

        #if defined(ETC_CHANNEL_SWIZZLE)
            // Swizzle ETC channels back into the expected order
            texelHDRNormal = texelHDRNormal.agbr; //NX,NY,NZ,HD -> HD,NY,NZ,NX
        #endif

        texelAlbedo = HDRScale(texelAlbedo, texelHDRNormal.r);
    #else
        getTexel(vTextureUV, textureSettings.textureMeta1, uAtlasMeta, textureSettings.wrapping, uTextureAtlas, texelAlbedo);
    #endif
    fragColour = texelAlbedo * vVertexAlbedo;
    fragColour *= fragColour; // A pretty necessary hack to compensate for the brightening of unlit objects caused by the 'linear to gamma' stage of tone mapping

    //Throw away any fragments which are below the set threshold for alpha testing
    if (fragColour.a <= uAlphaTestThreshold)
    {
        discard;
        return;
    }

    //Light scattering (now includes fog!)
    #if defined(LIGHT_SCATTERING) || defined(FOG_DISTANCE)
        fragColour.xyz = ApplyInOutScattering(fragColour.xyz, vOutScattering, vInScattering);
    #endif

    #if defined(HEAT_HAZE)
        fragColour.rgb = vec3(1.0, 1.0, 1.0);
    #endif

    gl_FragColor = fragColour;
}
