#include "Shared/ModelGeometryUtils.inc"
#include "Shared/ModelGeometryVertexUtils.inc"

void main()
{
    float label = 1.0;
    AssignPositionNormalVaryings(label);
#if !defined(USE_NORMAL_MAP)
    // Not doing normal mapping so might as well transform to view space now
    vNormal = normalize(Mat4ToMat3(uViewMatrix) * vNormal);
#endif

#if defined(VERTEX_COLOUR) && defined(ALPHA_ENABLED)
    vVertexAlbedo = aVertexColour;
#endif

    // Need to add a small epsilon due to interpolation error
    vMaterialSettingsSlotXY_BatchFlags.z = aVertexNormal_BatchFlags.w + (0.25 / 128.0);

#if defined(TEXTURE_ATLAS) && (defined(ALPHA_ENABLED) || defined(NORMAL_MAP))
    //Texture atlas data
    AssignTextureAtlasVaryings(vTextureUV, vMaterialSettingsSlotXY_BatchFlags.xy, aTextureUV, aMaterialSettingsSlotXY_TilePositionXZ.xy);
#endif
}
