#include "ParticleCommon.inc"

//Main function
void main()
{
    //Get vertex in camera space
    vWorldPosition = vec4(aParticleOrigin_CreationTime.xyz, 1.0);
    vec4 cameraSpacePosition;

    if (TestParticleFlag(int(aParticleUVAnimationData.w), PARTICLE_FLAG_HEADING_ALIGNED_BIT))
    {
        vec3 wsOriginDir = normalize(uCameraPosition.xyz - vWorldPosition.xyz);
        ApplyParticleOffset3DWS(vWorldPosition, aParticleVelocity, aParticleOffset, wsOriginDir);
        cameraSpacePosition = uViewMatrix * vWorldPosition;
    }
    else
    {
        cameraSpacePosition = uViewMatrix * vWorldPosition;
        ApplyParticleOffset2DVS(cameraSpacePosition, aParticleOffset, aMaterialSettingsSlotXY_Rotation.zw);
        vWorldPosition = uInvViewMatrix * cameraSpacePosition;
    }

    vec4 uv;
    float animationT;
    CalculateParticleUV(uv, animationT, aParticleOffset, aParticleOrigin_CreationTime.w, aParticleUVAnimationData);

    AssignParticleVaryings(aVertexColour, uv, animationT, aMaterialSettingsSlotXY_Rotation.xy);

    // Output linear view space depth
#if defined(SOFT_PARTICLES)
    vViewSpaceDepth = cameraSpacePosition.z;
#endif

    // Compute final clip space position
    gl_Position = uProjectionMatrix * cameraSpacePosition;
}
