#define PARTICLE_COMMON_TRANSFORMS_ONLY

#include "ParticleCommon.inc"

void main()
{
    // Get vertex in camera space
    vWorldPosition = vec4(aParticleOrigin_CreationTime.xyz, 1.0);
    vec4 cameraSpacePosition;

    if (TestParticleFlag(int(aParticleUVAnimationData.z), PARTICLE_FLAG_HEADING_ALIGNED_BIT))
    {
        vec3 wsOriginDir = normalize(uCameraPosition.xyz - vWorldPosition.xyz);
        ApplyParticleOffset3DWS(vWorldPosition, aParticleVelocity, aParticleOffset, wsOriginDir);
        cameraSpacePosition = uViewMatrix * vWorldPosition;
    }
    else
    {
        cameraSpacePosition = uViewMatrix * vWorldPosition;
        ApplyParticleOffset2DVS(cameraSpacePosition, aParticleOffset, aMaterialSettingsSlotXY_Rotation.zw);
    }

    // Compute final clip space position
    gl_Position = uProjectionMatrix * cameraSpacePosition;
}
