#include "ParticleCommon.inc"
#include "ShadowMapping.inc"

//Main function
void main()
{
    // Get vertex in camera space
    // Need to disable the minifier for this as it gets confused, presumably due to the TestParticleFlag use - see GT-4160
    //[
    vec4 vWorldPosition = vec4(aParticleOrigin_CreationTime.xyz, 1.0);
    vec4 cameraSpacePosition;

    if (TestParticleFlag(int(aParticleUVAnimationData.z), PARTICLE_FLAG_HEADING_ALIGNED_BIT))
    {
        vec3 wsOriginDir = normalize(uCameraPosition.xyz - vWorldPosition.xyz);
        ApplyParticleOffset3DWS(vWorldPosition, aParticleVelocity, aParticleOffset, wsOriginDir);
        cameraSpacePosition = uViewMatrix * vWorldPosition;
    }
    else
    {
        cameraSpacePosition = uViewMatrix * vWorldPosition;
        ApplyParticleOffset2DVS(cameraSpacePosition, aParticleOffset, aMaterialSettingsSlotXY_Rotation.zw);
    }
    //]

    vec4 uv;
    float animationT;

    CalculateParticleUV(uv, animationT, aParticleOffset, aParticleOrigin_CreationTime.w, aParticleUVAnimationData);

    AssignParticleVaryings(aVertexColour, uv, animationT, aMaterialSettingsSlotXY_Rotation.xy);

    // Compute final clip space position
    gl_Position = uProjectionMatrix * cameraSpacePosition;

    AdjustShadowClipSpaceZPos(gl_Position.z);
}
