#include "ShadowMapping.inc"

attribute vec3 aPos;
attribute float aCascadeIndex;

flat out float vColor;

uniform mat4 uWorldViewProjMats[MAX_ATLAS_CASCADES];
uniform float uCascadeColours[MAX_ATLAS_CASCADES];
// Previously this was a vec4, but various GPU drivers (i.e. Intel), don't support accessing 'vec' types using the array operator
//const vec4 cascadeColours = vec4(0.25, 0.5, 0.75, 1.0);

void main()
{
    const int iCascade = int(aCascadeIndex);
    vColor = uCascadeColours[GetConstantCascadeIndex(iCascade)];

    gl_Position = uWorldViewProjMats[GetConstantCascadeIndex(iCascade)] * vec4(aPos, 1.0);
}
