#ifndef DISTANCE_FOG_FUNCTIONS
#define DISTANCE_FOG_FUNCTIONS


#if defined(FOG_DISTANCE)

    float FogBasedOnDistance(highp float cameraDistance)
    {
        highp float fogAmount = (uFogParams.y - cameraDistance) * uFogParams.x;
        return 1.0 - clamp(fogAmount, 0.0, 1.0);
    }

    float FogBasedOnAngle(highp vec3 viewVec)
    {
        //Compute cosine between world up and world pos view vector.
        //Subtracting 1.0 from the cosine gives us the sine (i.e. height).
        //Note: Taking y component of viewVec directly rather than doing redundant dot with 0,1,0 zenith
        highp float cosFromZenith = 1.0 - clamp(viewVec.y + uFogParams.w, 0.0, 1.0);
        cosFromZenith = pow(cosFromZenith, uFogParams.z);
        return clamp(cosFromZenith, 0.0, 1.0);
    }

#endif


#endif
