#ifndef STIPPLE_COMMON_INC
#define STIPPLE_COMMON_INC

/**
  * This obtains the view space depth from the provided view space vector, and the view matrix.
  *
  * Note:
  * This is a faster alternative to calling GetViewSpaceDepthFromPos with uViewMatrix on Android devices, where
  * the shader compiler doesn't seem to handle mat4 arguments very well, even when we're just passing a uniform.
  */
highp float GetStippleViewSpaceDepthFromPos(vec3 viewVector)
{
    vec3 camLook = vec3(uViewMatrix[0][2], uViewMatrix[1][2], uViewMatrix[2][2]);
    return dot(viewVector, camLook);
}

#endif // STIPPLE_COMMON_INC
