
vec3 UnpackCompressedNormal(vec3 packedCompressedNormal)
{
    vec3 normal = vec3(packedCompressedNormal.zx * 255.0/127.0 - 128.0/127.0, 0.0);
    normal.z = sqrt(1.0 - min(1.0, dot(normal.xy, normal.xy)));
    normal.y = -normal.y;
    return normal;
}

vec3 UnpackNormal(vec3 packedNormal, float scale)
{
    vec3 normal;
    #if defined(COMPRESSED_NORMALS)
        normal = UnpackCompressedNormal(packedNormal);
    #else
        normal = packedNormal.zxy * 255.0/127.0 - 128.0/127.0;
        normal.y = -normal.y;
    #endif
    normal.xy *= scale;
    return normal;
}

vec3 UnpackNormal(vec3 packedNormal)
{
    return UnpackNormal(packedNormal, 1.0);
}

vec3 UnpackNormal(vec4 textureSample)
{
    return UnpackNormal(textureSample.yzw, 1.0);
}

vec3 UnpackNormal(vec4 textureSample, float scale)
{
    return UnpackNormal(textureSample.yzw, scale);
}
