//[ //You need special comments to prevent the obfuscator from touching this block
UNIFORM_BUFFER_BEGIN(ViewportLookupScale)
   // Width/height of the current viewport and their reciprocals
   // .x = 1/viewport Width, .y = 1/viewport height, .z = viewport width, .w = viewport height
   uniform highp vec4 uViewportLookupScale;
   // Offset and scale of the current viewport within the fullscreen RT (generally the backbuffer).
   // .x = vp x / backbuffer width, .y = vp y / backbuffer height, .z = vp width / backbuffer width, .w = vp height / backbuffer height
   uniform highp vec4 uViewportOffsetScale;
   // Width/height of the fullscreen RT (generally the backbuffer) and their reciprocals
   // .x = 1/backbuffer Width, .y = 1/backbuffer height, .z = backbuffer width, .w = backbuffer height
   uniform highp vec4 uFullScreenLookupScale;
UNIFORM_BUFFER_END
//]
