#include "Shared/StippleTransparencyUtils.inc"

#if defined(TEXTURE_ATLAS) && defined(NORMAL_MAP)
    #include "Shared/TerrainTexture.inc"
#endif

void main()
{
    vec3 normal = normalize(vNormal);
    highp vec3 worldPos = vWorldPosition;
    highp vec3 viewVector = worldPos - uCameraPosition;

#if defined(TEXTURE_ATLAS) && defined(NORMAL_MAP)
    vec4 texel;
    vec2 specularLevel_Exponent;
    float emissiveness = 0.0;
    float materialHighlight;
    SampleTerrainTextures(texel, specularLevel_Exponent, materialHighlight, normal, worldPos, viewVector, vec4(0.0), vec4(0.0), emissiveness);
    normal = normalize(Mat4ToMat3(uViewMatrix) * normal);
#endif

#if defined(STIPPLE_TRANSPARENCY_ENABLED)
    float stippleDummyAlpha = 1.0; // In theory, should optimize out the calculations under STIPPLE_TRANSPARENCY_ALPHA

    if (!IsStipplePixelVisible(viewVector, gl_FragCoord.xy, stippleDummyAlpha))
    {
        discard;
        return;
    }
#endif

    gl_FragColor = vec4(normal * 0.5 + 0.5, 1.0);
}
