#ifndef SHADOW_UTILS_INC
#define SHADOW_UTILS_INC

float ShadowFadeSmooth(float shadowAtten, highp float pixelViewDepth, highp float fadeStartDst, highp float fadeEndDst)
{
    float step = smoothstep(fadeStartDst, fadeEndDst, pixelViewDepth);
    return mix(shadowAtten, 1.0, step);
 }

float ShadowFade(float shadowAtten, highp float pixelViewDepth, highp float fadeStartDst, highp float invFadeRange)
{
    float step = clamp((pixelViewDepth - fadeStartDst) * invFadeRange, 0.0, 1.0);
    return mix(shadowAtten, 1.0, step);
}

vec4 ShadowMapCascadeColour(int iCascadeLOD, int cascadeLODCount)
{
    vec3 cascadeColorsMultiplier = vec3(equal(ivec3(0, 1, 2), ivec3(iCascadeLOD)));
    cascadeColorsMultiplier += vec3(equal(ivec3(3, cascadeLODCount, 3), ivec3(iCascadeLOD)));
    return vec4(cascadeColorsMultiplier, 1.0);
}

#endif
